import { Button } from "@/components/button";
import React, { useState } from "react";
import { useTranslation } from "react-i18next";
import * as yup from "yup";
import { useForm } from "react-hook-form";
import { yupResolver } from "@hookform/resolvers/yup";
import { ConfirmationResult } from "@firebase/auth";
import { error } from "@/components/alert";
import { useAuth } from "@/hook/use-auth";
import { ForgotPasswordViews } from "@/components/auth/types";
import useAddressStore from "@/global-store/address";
import { PhoneInput } from "@/components/phone-input";

interface ForgotPasswordFormProps {
  onChangeView: (view: ForgotPasswordViews) => void;
  onSuccess: (data: { credential: string; callback?: ConfirmationResult }) => void;
}

const schema = yup.object({
  phone: yup.string().required(),
});

type FormData = yup.InferType<typeof schema>;

const Form = ({ onChangeView, onSuccess }: ForgotPasswordFormProps) => {
  const { t } = useTranslation();
  const country = useAddressStore((state) => state.country);
  const { phoneNumberSignIn } = useAuth();
  const [isSubmitting, setIsSubmitting] = useState(false);
  const {
    formState: { errors },
    handleSubmit,
    watch,
    setValue,
  } = useForm<FormData>({
    resolver: yupResolver(schema),
  });

  const handleCheckCredential = (data: FormData) => {
    setIsSubmitting(true);
    phoneNumberSignIn(data.phone as string, { mode: "forgot" })
      .then((value) => {
        onSuccess({
          credential: data.phone as string,
          callback: value as any,
        });
        onChangeView("VERIFY");
      })
      .catch((err) => {
        error(err?.message || t("sms.not.sent"));
      })
      .finally(() => {
        setIsSubmitting(false);
      });
  };

  return (
    <div className="flex flex-col gap-6 ">
      <h1 className="font-semibold text-[30px] mb-2 text-start">{t("forgot.password")}</h1>
      <form id="forgot" onSubmit={handleSubmit(handleCheckCredential)}>
        <div className="flex flex-col gap-3 mb-3 w-full">
          <PhoneInput
            country={country?.code}
            value={watch("phone")}
            error={errors.phone?.message}
            onChange={(value) => setValue("phone", value)}
          />
        </div>
      </form>
      <Button id="sign-in-button" loading={isSubmitting} form="forgot" type="submit" fullWidth>
        {t("submit")}
      </Button>
    </div>
  );
};

export default Form;
